#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:


#ce ----------------------------------------------------------------------------

Func _configWrite($ip, $port, $prev, $winSize)
	IniWrite($__ConfigIni, "", "ip", $ip)
	IniWrite($__ConfigIni, "", "port", $port)
	IniWrite($__ConfigIni, "", "preview", $prev)
	IniWrite($__ConfigIni, "", "winSize", $winSize)
	$__configArray[0] = 4
	$__configArray[1] = $ip
	$__configArray[2] = $port
	$__configArray[3] = $prev
	$__configArray[4] = $winSize
EndFunc

Func _configGet($what)
	Switch $what
		Case "ip"
			Return IniRead($__ConfigIni, "", "ip", @IPAddress1)
		Case "port"
			Return IniRead($__ConfigIni, "", "port", 80)
		Case "preview"
			Return IniRead($__ConfigIni, "", "preview", $GUI_CHECKED)
		Case "winSize"
			Return IniRead($__ConfigIni, "", "winSize", "320x240")
	EndSwitch
EndFunc

Func _togglePrevWindow()
	If $prevWin_stat Then
		GUISetState(@SW_HIDE, $prev_gui)
		$prevWin_stat = False
	Else
		GUISetState(@SW_SHOW, $prev_gui)
		GUISetState(@SW_ENABLE, $prev_gui)
		$prevWin_stat = True
	EndIf
EndFunc

Func _setNewNetConfig()
	_config($__configArray, 1)
	_TCP_Server_Stop()
	_startServer($__configArray[1], $__configArray[2])
EndFunc

Func _startServer($ip, $port)
	$__tcpServerHandle = _TCP_Server_Create($port, $ip)
	_TCP_RegisterEvent($__tcpServerHandle, $TCP_RECEIVE, "_tcpReceive")
	$__broadcastStat = True
	TrayTip("Webcam broadcast", "Online!" & @CRLF & $ip & ":" & $port, 1)
	TraySetToolTip("Online - " & $ip & ":" & $port)
	ConsoleWrite("!> Server online: " & $ip & ":" & $port & @CRLF)
EndFunc
