#NoTrayIcon
#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=webcam.ico
#AutoIt3Wrapper_Compression=4
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:


#ce ----------------------------------------------------------------------------

Opt("TrayMenuMode", 11)
Opt("TrayOnEventMode", 1)

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiIPAddress.au3>
#include <WindowsConstants.au3>

#include <String.au3>
#include <GDIPlus.au3>

#include <Perso\TCP.au3>
#include <Perso\WebCam.au3>

Global $__ConfigIni = @TempDir & "\cctv_config.ini", $__snapFile = @ScriptDir & "\wcbSnap.jpg"
Global $__configArray[5] ; 1 = ip, 2 = port, 3 = preview, 4 = preview size
Global $__tcpServerHandle, $__broadcastStat = False, $__refreshRate = 1 ; in seconds
Global $prev_gui, $wc_cap, $prevWin_stat = False ; Preview window

#include "cctv_func.au3"

If $CmdLine[0] >= 2 And $CmdLine[0] <= 4 Then
	If $CmdLine[0] = 2 Then
		_broadcast($CmdLine[1], $CmdLine[2])
	ElseIf $CmdLine[0] = 3 Then
		_broadcast($CmdLine[1], $CmdLine[2], Int($CmdLine[3]))
	ElseIf $CmdLine[0] = 4 Then
		_broadcast($CmdLine[1], $CmdLine[2], Int($CmdLine[3]), $CmdLine[4])
	EndIf
EndIf

_config($__configArray)
_broadcast($__configArray[1], $__configArray[2], $__configArray[3], $__configArray[4])

Func _config(ByRef $__configArray, $onlyNetSettings = 0)
	Local $config_gui, $hIPAddress, $hInputPort, $hCheck_preview, $hCombo_prevSize, $B_ok, $accel[1][2] ; Config GUI
	#Region ### START Koda GUI section ### Form=
	$config_gui = GUICreate("CCTV Configuration", 219, 82)
	$hIPAddress = _GUICtrlIpAddress_Create($config_gui, 8, 8, 130, 21)
	_GUICtrlIpAddress_Set($hIPAddress, _configGet("ip"))
	$hInputPort = GUICtrlCreateInput(_configGet("port"), 144, 8, 65, 21)
	$hCheck_preview = GUICtrlCreateCheckbox("Preview window", 8, 34, 97, 17)
	GUICtrlSetState(-1, _configGet("preview"))
	$hCombo_prevSize = GUICtrlCreateCombo("128x96", 112, 32, 97, 25)
		GUICtrlSetData(-1, "176x128|320x240|640x480|800x600", _configGet("winSize"))
	$B_ok = GUICtrlCreateButton("OK", 72, 56, 75, 21, $WS_GROUP)
	$accel[0][0] = "{enter}"
	$accel[0][1] = $B_ok
	GUISetAccelerators($accel, $config_gui)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	If $onlyNetSettings Then
		GUICtrlSetState($hCheck_preview, $GUI_DISABLE)
		GUICtrlSetState($hCombo_prevSize, $GUI_DISABLE)
	EndIf

	#region - GUI SelectLoop
	While 1
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE
				If $onlyNetSettings Then
					GUIDelete($config_gui)
					ExitLoop
				Else
					Exit
				EndIf
			Case $msg = $B_ok
				$__IP = _GUICtrlIpAddress_Get($hIPAddress) ; ###
				$__Port = GUICtrlRead($hInputPort) ; ###
				$__Preview = GUICtrlRead($hCheck_preview) ; ###
				$__prevWinSize = GUICtrlRead($hCombo_prevSize) ; ###
				_configWrite($__IP, $__Port, $__Preview, $__prevWinSize)
				GUIDelete($config_gui)
				ExitLoop
		EndSelect
	WEnd
	#endregion
EndFunc

Func _broadcast($ip, $port, $prev = 1, $prevSize = "320x240")
	Local $t_broadcast, $t_config, $t_prev, $t_quit ; Tray
	$t_broadcast = TrayCreateItem("Toggle broadcast")
		TrayItemSetOnEvent(-1, "_toggleBroadcast")
	TrayCreateItem("")
	$t_config = TrayCreateItem("Configuration")
		TrayItemSetOnEvent(-1, "_setNewNetConfig")
	$t_prev = TrayCreateItem("Toggle preview window")
		TrayItemSetOnEvent(-1, "_togglePrevWindow")
	TrayCreateItem("")
	$t_quit = TrayCreateItem("Quit")
		TrayItemSetOnEvent(-1, "_quit")

	$prevSize = StringSplit($prevSize, "x")
	$prev_gui = GUICreate("Webcam broadcast", $prevSize[1], $prevSize[2])
	$wc_cap = _Webcam_Open($prev_gui, 0, 0, $prevSize[1], $prevSize[2])

	If $prev = $GUI_CHECKED Then
		$prevWin_stat = True
		GUISetState()
	EndIf

	TraySetState(1)
	TraySetClick(18)

	_GDIPlus_Startup()
	_startServer($ip, $port)

	While 1
		$guiMsg = GUIGetMsg()
		Switch $guiMsg
			Case $GUI_EVENT_CLOSE
				_quit()
			Case $GUI_EVENT_MINIMIZE
				_togglePrevWindow()
		EndSwitch
	WEnd
EndFunc

Func _tcpReceive($hSocket, $sReceived, $iError)
	Local $toBeSent, $hFile
	If $__broadcastStat Then _Webcam_Snap($wc_cap, $__snapFile)
	If StringInStr($sReceived, "GET") Then $sReceived = _StringBetween($sReceived, "GET /", " HTTP/1.1")
	If IsArray($sReceived) Then $sReceived = $sReceived[0]
	ConsoleWrite("+> " & _TCP_Server_ClientIP($hSocket) & " <-- " & $sReceived & @CRLF & "	- Snap ok (" & FileGetSize($__snapFile) & ") sending ...")
	If Not $sReceived = "" Then
		If $__broadcastStat Then
			$hFile = FileOpen($__snapFile, 16)
			$toBeSent = FileRead($hFile, FileGetSize($__snapFile))
			FileClose($hFile)
		Else
			$toBeSent = ""
		EndIf
	Else
		$toBeSent = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">'& _
					'<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">'& _
					'<title>Webcam Broadcast</title>'& _
					'<script language="JavaScript">'& _
					'var camID = 0;'& _
					'function UpdateCam() {if(camID) {clearTimeout(camID);camID  = 0;}document.scrshot.src = "wcbSnap.jpg?" + Math.random();camID = setTimeout("UpdateCam()", ' & ($__refreshRate * 1000) & ');document.getElementById("tstamp").innerHTML = Date();}'& _
					'function StartCam() {camID = setTimeout("UpdateCam()", ' & ($__refreshRate * 1000) & ');}'& _
					'function KillCam() {if(camID) {clearTimeout(camID);camID  = 0;}}'& _
					'</script>'& _
					'</head>'& _
					'<body onload="StartCam()" onUnload="KillCam()"><center><img name="scrshot" src="'
		If $__broadcastStat Then $toBeSent &= "wcbSnap.jpg"
		$toBeSent &= '">'& _
					'<div id="tstamp"></div>'& _
					'</center></body>'& _
					'</html>'
	EndIf
	_TCP_Send($hSocket, $toBeSent)
	ConsoleWrite(" Done!" & @CRLF)
	_TCP_Server_DisconnectClient($hSocket)
EndFunc

Func _toggleBroadcast()
	If Not $__broadcastStat Then
		$__broadcastStat = True
	Else
		$__broadcastStat = False
	EndIf
EndFunc

Func _quit()
	_TCP_Server_Stop()
	_WebCam_Close($wc_cap)
	_GDIPlus_Shutdown()
	GUIDelete($prev_gui)
	Exit
EndFunc
